unit Unit6;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ComCtrls;

type
  TForm6 = class(TForm)
    testy: TListBox;
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    progress: TProgressBar;
    procedure Button1Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure testyKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure Button2Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

const typ  :array[0..2] of string = ('Integer', 'Extended', 'Interval');

var
  Form6: TForm6;

implementation

uses Unit3, prog_ean, Unit5, IntervalArithmetic;

{$R *.dfm}

procedure TForm6.Button1Click(Sender: TObject);
begin
if losowa_dialog.ShowModal = mrOk then
  begin
  testy.Items.Add(losowa_dialog.losowa_h.Text+'x'+
                  losowa_dialog.losowa_w.Text+' '+
                  typ[losowa_dialog.losowa_vt.ItemIndex]+
                  ' '+losowa_dialog.losowa_wykmin.Text+' '+
                  losowa_dialog.losowa_wykmax.Text);
  end;
end;

procedure TForm6.Button3Click(Sender: TObject);
begin
if testy.ItemIndex<> -1 then
  testy.Items.Delete(testy.ItemIndex);
end;

procedure TForm6.testyKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
if (key=VK_DELETE) and (testy.ItemIndex<>-1) then
  testy.Items.Delete(testy.ItemIndex);
end;

procedure TForm6.Button2Click(Sender: TObject);
var i, j, k, h, w, wykmin, wykmax :integer;
  str,substr, styp :string;
  vt :Tdatatype;
  det, zero, one, minus_one :Tvalue;
  cmpval, blad, blad_max :Tvalue;
begin
dialog_wyznacznik.wynik.Lines.Clear;
dialog_wyznacznik.wynik.Lines.Add('n typ wykmin wykmax det_width sumcnt mulcnt errcnt blad blad_width');
progress.Max := testy.Items.Count;
progress.Position := 0;

for k:= 0 to testy.Items.Count-1 do
  begin
    progress.StepIt;
    str := testy.Items[k];
    substr := copy(str, 0, pos('x', str)-1);
    str := copy(str, pos('x', str)+1, length(str));
    h := StrToInt(substr);

    substr := copy(str, 0, pos(' ',str)-1);
    str := copy(str, pos(' ', str)+1, length(str));
    w := StrToInt(substr);

    substr := copy(str, 0, pos(' ',str)-1);
    str := copy(str, pos(' ', str)+1, length(str));
    if substr='Integer' then vt := Tinteger;
    if substr='Extended' then vt := Textended;
    if substr='Interval' then vt := Tinterval;
    styp := substr;

    substr := copy(str, 0, pos(' ',str)-1);
    str := copy(str, pos(' ', str)+1, length(str));
    wykmin := StrToInt(substr);
    wykmax := StrToInt(str);

    try
      a := Tmatrix.CreateRandom(h, w, vt, wykmin, wykmax);
    except
      on EInvalidOp do
        showmessage('Blad podczas losowania liczb. Przekroczono zakres typu. Wybierz mniejsze wykladniki, lub bardziej pojemny typ danych');
    end;
    Ainv := Tmatrix.Create(h, w, vt);
    L := Tmatrix.Create(h, w, vt);
    U := Tmatrix.Create(h, w, vt);
    AAinv := Tmatrix.Create(h, w, vt);

    if A<>nil then
      begin
      zero_counters;
      zero := Tvalue.Create(a.vtype);
      one := Tvalue.Create(a.vtype);
      minus_one := Tvalue.Create(a.vtype);
      minus_one.setval(-1);
      zero.setval(0);
      one.setval(1);
      blad := Tvalue.Create(a.vtype);
      blad_max := Tvalue.Create(a.vtype);
      blad.setval(zero);
      blad_max.setval(zero);

      det := Tvalue.Create(a.vtype);
      Ainv := A.odwroc(det);
      if Ainv<>nil then
        begin
        AAinv := A.mmul(Ainv);

        for i := 0 to AAinv.height-1 do
          for j := 0 to AAinv.width-1 do
            begin
            if i=j then
              cmpval := one
           else
              cmpval := zero;

          blad := AAinv.items[i, j].osub(cmpval);
          if blad.greaterthan(blad_max) then
            blad_max.setval(blad)
          else
            begin
            blad.vmul(minus_one);
            if blad.greaterthan(blad_max) then
              blad_max.setval(blad);
            end;
          end;

    str := IntToStr(w)+' '+styp+' '+IntToStr(wykmin)+' '+IntToStr(wykmax);
    if a.vtype = Tinterval then
      str := str + ' ' + FloatToStr(int_width(det.getv))
    else
      str := str + ' 0';
    str := str + ' ' + IntToStr(sumcounter) + ' ' + IntToStr(mulcounter) + ' ';
    str := str + ' ' + IntToStr(errmulcounter) + ' ' + blad_max.toString;
    if a.vtype = Tinterval then
      str := str + ' '+FloatToStr(int_width(blad_max.getv))
    else
      str := str + ' 0';
  dialog_wyznacznik.wynik.Lines.Add(str);
  end
end;
  end;
dialog_wyznacznik.Show;
progress.Position := 0;
end;

end.
