#/bin/sh

if [ $# -lt 2 ]; then
  echo $0 liczba_testow [opcje generatora]
  exit
fi

l=$1;
shift;

lt=0;
max=0;
min=99999999999;
sum=0;

for i in `seq 1 $l`; do
    ../generator ${@} -o dane$i.txt;
    lt=`head -1 dane$i.txt`
    wynik=$(../szereguj_dokl dane$i.txt | wc -l);
    let wynik--
    let sum+=wynik
    if [ $wynik -gt $max ]; then
	max=$wynik
    fi
    if [ $wynik -lt $min ]; then
	min=$wynik
    fi
done;

f="`../factorial $lt`"
avg=$(( $sum/$l))
min_pr=0`echo "scale=4;$min/$f" |bc`
max_pr=0`echo "scale=4;$max/$f" |bc`
avg_pr=0`echo "scale=4;$avg/$f" |bc`
printf "min=%6d (%6s) avg=%6d (%6s) max=%6d (%6s) %6d!=%6d\n" $min $min_pr $avg $avg_pr $max $max_pr $lt $f 

