#include <stdio.h>
#include "struktury.h"

/*
szereguj(lprocesorow, dane)
{
    sortuje dane wg d od najmniejszego do najwiekszego // QUICKSORT
    przydziela do procesorow i oblicza opoznienie jednoczesnie i 
        pamieta najw.opoznienie
}
*/
int szereguj(int ltasks,struct dane *wejscie)
{
 int i,lmax,pr,lproc=3;
 struct procesor *procesory;
 procesory=(struct procesor*)malloc(lproc*sizeof(struct procesor));
  for(i=0;i<lproc;i++)
 {
   procesory[i].wolny_od=0;
 }
 
// quicksort(0, ltasks-1, wejscie);
 for (i=0;i<ltasks;i++) 
 {
   przydziel_procesor(procesory, &wejscie[i]);
   printf("%d ", wejscie[i].num);
   if (i==0 || wejscie[i].l>lmax) {lmax=wejscie[i].l; }
//   printf("(%d,%d,%d,%d)[%d,%d] ", wejscie[i].num, wejscie[i].c, wejscie[i].d, wejscie[i].l, pr, procesory[pr].wolny_od);
//   printf("zad (%d,%d,%d,%d) do proc %d\n", wejscie[i].num, wejscie[i].c, wejscie[i].d, wejscie[i].l, pr);
 }
 printf(" wynik %d\n", lmax);
// stan(wejscie, lproc, ltasks);
 free(procesory);
 return lmax;
}

/*
napisac komentarz
*/

/* permut(wejscie) */
int permut(struct dane *wejscie, int size, struct dane *buf, int bufsize)
{
    int i, l, lmax;
    //    struct dane tmp;

    if(size == 0) 
    {
	return szereguj(bufsize, buf);
    }

    for (i=0; i<size; i++)
    {
//	printf("w buf: %d->%d, w wejscie: %d<->%d\n", wejscie[i].num, bufsize-size, wejscie[i].num, wejscie[size-1].num);
	memcpy(&buf[bufsize-size], &wejscie[i], sizeof(struct dane));
	//	memcpy(&tmp, &wejscie[i], sizeof(struct dane));
	memcpy(&wejscie[i], &wejscie[size-1], sizeof(struct dane));
	l = permut(wejscie, size-1, buf, bufsize);
	memcpy(&wejscie[size-1], &wejscie[i], sizeof(struct dane));
	memcpy(&wejscie[i], &buf[bufsize-size], sizeof(struct dane));
	if (l < lmax || i==0)
	    lmax = l;
    }
    return lmax;
}

/*
main()
*/
int main(int argc, char *argv[]) {
  struct dane *wejscie, *buf;
  int lproc,ltasks,i,lmax;
  if (argc<=1)
  {
    printf("Podaj argument\n");
    exit(1);
  }
 wejscie = pobierz_dane(argv[1],&ltasks);
 buf = (struct dane*) malloc(ltasks*sizeof(struct dane));
 lmax = permut(wejscie, ltasks, buf, ltasks);

 printf("%d\n",lmax);
 free(buf);
 free(wejscie);
 
}

