/****
   LTPS - Linux Text Presentation System
                                       ****/

#include "common.h"

#include "style.h"

using namespace std;

Style:: Style()
{
  this->color = 0;
  this->background_color = 0;
  this->align = ha_left;
  this->vertical_align = va_top;
  this->margin_left = 0;
  this->margin_right = 0;
  this->margin_top = 0;
  this->margin_bottom = 0;
}

Style::Style(Color color, Color background_color, Alignment align, Vertical_alignment vertical_align, 
       int margin_left, int margin_right, int margin_top, int margin_bottom)
{
  this->color = color;
  this->background_color = background_color;
  this->align = align;
  this->vertical_align = vertical_align;
  this->margin_left = margin_left;
  this->margin_right = margin_right;
  this->margin_top = margin_top;
  this->margin_bottom = margin_bottom;
}
