/****
   LTPS - Linux Text Presentation System
                                       ****/

#ifndef TMP_TRANSITION
#define TMP_TRANSITION

using namespace std;

class Transition 
{
 public:
  Transition();
  Transition(char* opts);
  
  int virtual execute(char*** data, int width, int height);
};

class Trans_Up2Down :public Transition 
{
 public:
  int virtual execute(char*** data, int width, int height);
};

class Trans_Left2Right :public Transition 
{
 public:
  int virtual execute(char*** data, int width, int height);
};

class Trans_Center2Borders : public Transition
{
 public:
  int virtual execute(char*** data, int width, int height);
};

class Trans_MoveFromLeft : public Transition
{
 public:
  int virtual execute(char*** data, int width, int height);
};

class Trans_Matrix :public Transition 
{
 public:
  int virtual execute(char*** data, int width, int height);
};

#endif
