/****
   LTPS - Linux Text Presentation System
                                       ****/

#include <ncurses.h>

#include "options.h"
#include "slides.h"

using namespace std;

int main(int argc, char** argv)
{
  Options command_line_args(argc, argv);
  Slides  presentation(command_line_args.get_filename());

  initscr();
  noecho();
  curs_set(0);

  presentation.play();

  endwin();

  return 0;
}
