unit Unit3;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls;

type
  Tlosowa_dialog = class(TForm)
    losowa_panel: TPanel;
    wzor_label: TLabel;
    Label3: TLabel;
    Label6: TLabel;
    Label5: TLabel;
    Label2: TLabel;
    Label1: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    wzor_wykmin: TLabel;
    wzor_wykmax: TLabel;
    losowa_wykmax: TEdit;
    losowa_wykmin: TEdit;
    losowa_h: TEdit;
    losowa_w: TEdit;
    losowa_vt: TComboBox;
    losowa_rzad: TComboBox;
    Button1: TButton;
    Button2: TButton;
    procedure losowa_rzadChange(Sender: TObject);
    procedure losowa_wykminChange(Sender: TObject);
    procedure losowa_wykmaxChange(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure losowa_wChange(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    procedure aktualizuj_wzor;
  end;

var
  losowa_dialog: Tlosowa_dialog;

implementation

{$R *.dfm}

procedure Tlosowa_dialog.aktualizuj_wzor;
var spacje1, spacje2 :string;
    i :integer;
begin
wzor_wykmin.Caption := losowa_wykmin.Text;
wzor_wykmax.Left := 138 + Length(wzor_wykmin.Caption)*6;
for i := 1 to Length(wzor_wykmin.Caption) do spacje1 := spacje1+'  ';
wzor_wykmax.Caption := losowa_wykmax.Text;
for i := 1 to Length(wzor_wykmax.Caption) do spacje2 := spacje2+'  ';
wzor_label.Caption := '(10 '+spacje1+',  10 '+spacje2+' )';
end;

procedure Tlosowa_dialog.losowa_rzadChange(Sender: TObject);
begin
case losowa_rzad.ItemIndex of
  0:begin // zblione due liczby
    losowa_wykmin.Text := '20';
    losowa_wykmax.Text := '22';
    end;
  1:begin // rozne duze liczby
    losowa_wykmin.Text := '10';
    losowa_wykmax.Text := '30';
    end;
  2:begin // zblizone male liczby
    losowa_wykmin.Text := '-1';
    losowa_wykmax.Text := '1';
    end;
  3:begin // rozne male liczby
    losowa_wykmin.Text := '-5';
    losowa_wykmax.Text := '5';
    end;
  4:begin // zblizone bardzo male
    losowa_wykmin.Text := '-22';
    losowa_wykmax.Text := '-20';
    end;
  5:begin // rozne bardzo male
    losowa_wykmin.Text := '-30';
    losowa_wykmax.Text := '-10';
    end;
  6:begin // caly przedzial
    losowa_wykmin.Text := '-30';
    losowa_wykmax.Text := '30';
    end;
end;
aktualizuj_wzor;
end;

procedure Tlosowa_dialog.losowa_wykminChange(Sender: TObject);
begin
aktualizuj_wzor;
end;

procedure Tlosowa_dialog.losowa_wykmaxChange(Sender: TObject);
begin
aktualizuj_wzor;
end;

procedure Tlosowa_dialog.Button1Click(Sender: TObject);
begin
self.ModalResult := mrOk;
end;

procedure Tlosowa_dialog.Button2Click(Sender: TObject);
begin
self.ModalResult := mrCancel;
end;

procedure Tlosowa_dialog.losowa_wChange(Sender: TObject);
begin
losowa_w.Text := losowa_h.Text;
end;

end.
