unit Unit7;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ExtCtrls;

type
  TForm7 = class(TForm)
    procedure FormPaint(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form7: TForm7;

implementation

  uses prog_ean;
{$R *.dfm}

procedure TForm7.FormPaint(Sender: TObject);
var det, zero, one, minus_one :Tvalue;
    cmpval, blad, blad_max :Tvalue;
    i, j, size :integer;
begin

  zero := Tvalue.Create(a.vtype);
  one := Tvalue.Create(a.vtype);
  minus_one := Tvalue.Create(a.vtype);
  minus_one.setval(-1);
  zero.setval(0);
  one.setval(1);

  blad := Tvalue.Create(a.vtype);
  blad.setval(zero);
  blad_max := Tvalue.Create(a.vtype);
  blad_max.setval(zero);

form7.Canvas.Brush.Color := clRed;
form7.Canvas.Brush.Style := bsSolid;
form7.Canvas.Pen.Color := clBlack;
form7.Canvas.Pen.Style := psSolid;

if AAinv <> nil then
  begin
  size := form7.Width div AAinv.width;

  for i := 0 to AAinv.height-1 do
      for j := 0 to AAinv.width-1 do
        begin
        if i=j then
          cmpval := one
        else
          cmpval := zero;

        blad := AAinv.items[i, j].osub(cmpval);
        if blad.greaterthan(blad_max) then
          blad_max.setval(blad)
        else
          begin
          blad.vmul(minus_one);
          if blad.greaterthan(blad_max) then
            blad_max.setval(blad);
          end;
        end;

  for j := 0 to AAinv.height-1 do
    for i := 0 to AAinv.width-1 do
      begin
        form7.Canvas.Brush.Color := i*30;
        form7.Canvas.FillRect(Rect(i*size, j*size, (i+1)*size, (j+1)*size));
        form7.Canvas.Rectangle(Rect(i*size, j*size, (i+1)*size, (j+1)*size));
      end;
  end;
end;

end.
