// Super eXtra

import java.io.*;
import java.util.*;

public class prog_66305_66301 {
    static int i;
    public static void main(String[] args) {
	BufferedReader stdin = new BufferedReader(
           new InputStreamReader(System.in));
	CDane MojeDane = new CDane();
	try {
	    System.out.print("Podaj nazwe pliku z danymi: ");
	    MojeDane.SetNazwaPliku(stdin.readLine());
	    MojeDane.CzytajDane();
	    
	} catch (IOException e)
	    {
		System.out.println("Blad we/wy");
	    }
  }
}

class CDane
{
    protected String NazwaPliku;
    protected int TypPliku;
    protected CRaport Raport;
    protected CStatystyka Statystyka;
    protected CWartosc[] Wartosc;

    public void CzytajDane() throws IOException
    {
	int i = 0;
	BufferedReader in = new BufferedReader(
	    new FileReader(NazwaPliku));
	try 
	    {
		//		Wartosc = new CWartoscLiczbowa();
		while (true)
		    {
			Wartosc[i] = new CWartoscLiczbowa();
			Wartosc[i].CzytajWartosc(in);
			i++;	
		    }
	    } catch(IOException e) {
		in.close();
	    }
    }

    public void ZapiszDane()
    {
	int i = 0;

	try {
	    PrintWriter out = new PrintWriter(
	      new BufferedWriter(new FileWriter(NazwaPliku)));
	    while(i < Wartosc.length)
		{
		    Wartosc[i].ZapiszWartosc(out);
		    i++;
		}
	    out.close();
	} catch(IOException e) {
	}
    }

    public void SetNazwaPliku(String nazwa) 
    {
	NazwaPliku = nazwa;
	System.out.println("Ustawiono nazwe pliku: " + NazwaPliku);
    }

    public CWartosc[] GetWektorDanych() 
    {
	return Wartosc;
    }
};

class CRaport
{
    protected String NazwaPliku;
    protected boolean ZapisacDane;
    protected int Precyzja;
    protected CDane Dane;
    protected CStatystyka Statystyka;
    public void ZapiszRaport()
    {
	if (ZapisacDane)
	    {
		Dane.SetNazwaPliku(NazwaPliku);
		Dane.ZapiszDane();
	    }
	
	try {
	    PrintWriter out = new PrintWriter(
	      new BufferedWriter(new FileWriter(NazwaPliku)));
	    Statystyka.ZapiszStatystyka(out);
	    out.close();
	} catch(IOException e) {
	}
    }

    public void SetZapisacDane(boolean x) 
    {
	ZapisacDane = x;
    }

    public void SetPrecyzja(int x) 
    {
	Precyzja = x;
    }
};

abstract class CStatystyka
{
    protected CDane Dane;
    protected CRaport Raport;
    abstract void ZapiszStatystyka(PrintWriter out);
    abstract void Oblicz();
};

class CSredniaArytmetyczna extends CStatystyka
{
    protected double WartoscStatystyki;
    public void ZapiszStatystyka(PrintWriter out) 
    {
	out.println("Srednia arytmetyczna = " + WartoscStatystyki);
    }

    public void Oblicz() 
    {
	int i = 0;
	WartoscStatystyki = 0;
	while(i < Dane.Wartosc.length)
	    {
		WartoscStatystyki += Dane.Wartosc[i].KonwertujDoInt();
		i++;
	    }
	WartoscStatystyki = WartoscStatystyki / Dane.Wartosc.length;
	
    }
};

class CSredniaLiczbaWartosci extends CStatystyka
{
    protected double WartoscStatystyki;
    public void ZapiszStatystyka(PrintWriter out) 
    {
	out.println("Srednia liczba wartosci = " + WartoscStatystyki);
    }

    public void Oblicz() 
    {
	// ?????????????????????????????????
	// Czym jest Srednia liczba wartosci
	// ?????????????????????????????????
    }

};

abstract class CWartosc
{
    protected CDane Dane;
    abstract void ZapiszWartosc(PrintWriter out) throws IOException;
    abstract void CzytajWartosc(BufferedReader in) throws IOException;
    abstract int KonwertujDoInt();
    abstract String KonwertujDoString();
};

class CWartoscNominalna extends CWartosc
{
    protected String Wartosc;
    public void ZapiszWartosc(PrintWriter out) throws IOException
    {
	out.println(Wartosc);
    }

    public void CzytajWartosc(BufferedReader in) throws IOException
    {
	Wartosc = new String(in.readLine());
    }

    public int KonwertujDoInt() 
    {
	Integer i = new Integer(Wartosc);
	return i.intValue();
    }

    public String KonwertujDoString() 
    {
	return Wartosc;
    }
};

class CWartoscLiczbowa extends CWartosc
{
    protected int Wartosc;
    public void ZapiszWartosc(PrintWriter out) throws IOException
    {
	Integer i = new Integer(Wartosc);
	out.println(i.toString());
    }

    public void CzytajWartosc(BufferedReader in) throws IOException
    {
	Integer i = new Integer(in.readLine());
	Wartosc = i.intValue();
    }

    public int KonwertujDoInt() 
    {
	return Wartosc;
    }
    public String KonwertujDoString() 
    {
	Integer i = new Integer(Wartosc);
	return i.toString();
    }
};

