next(A, [A,B|_], B).
next(A, [_|Tail], B) :- next(A, Tail, B).

ocurrences([], A, 0).
ocurrences([A|Tail], A, N1) :- ocurrences(Tail, A, N), N1 is N+1.
ocurrences([_|Tail], A, N) :- ocurrences(Tail, A, N).

del(A, [], []).
del(A, [A|T1], T2) :- del(A, T1, T2).
del(A, [X|T1], [X|T2]) :- del(A, T1, T2).

ucount([], 0).
ucount([H|T], N) :- member(H, T), !, ucount(T, N).
ucount([_|T], N1) :- ucount(T, N), N1 is N+1.

heads([], []).
heads([[H|L]|T], [H|R]) :- heads(T, R).