/****
   LTPS - Linux Text Presentation System
                                       ****/

#ifndef TMP_SLIDES
#define TMP_SLIDES

#include <vector>

#include "slide.h"

#define XML_IN_PRESENTATION 1
#define XML_IN_HEAD         2
#define XML_IN_SLIDES       4
#define XML_IN_SLIDE        8

using namespace std;

class Slides {
 private:
  vector <Slide*> slides;
  char*  author;
  char*  title;

public:
  Slides(void);
  Slides(char* filename);
  ~Slides(void);
  void play(void);

  void setauthor(char*newauthor, int len);
  char* getauthor(void);
  void settitle(char*newtitle, int len);
  char* gettitle(void);


  friend void xml_chartag(void *data, const char *s, int len);
  friend void xml_opentag(void *data, const char *el, const char **attr);
  friend void xml_closetag(void *data, const char *el);
};

#endif
