#include<sys/ipc.h>
#include<sys/msg.h>
#include<signal.h>

#include "protocol.h"
#include "function.c"
#include "headers.h"
#include "klientproc.c"

int inmsg_id;
int outmsg_id;
char name[PROTO_ARGSIZE];
message in_message;
message out_message;
char client_name[PROTO_ARGSIZE]={0};
char arg1[PROTO_ARGSIZE]={0}, arg2[PROTO_ARGSIZE]={0}, path[256]={0};
char downloadDir[]="Download";

void clear(int signal);

//**************************************************************************************
void join_serwer_canal()
{if((outmsg_id=msgget(SERVERID,0))==-1)
   {perror("Nie znaleziono koanalu serwera!!!"); exit(0);}
 printf("\n\E[0m \E[2J  \E[1;0H \E[1;46m    :: K L I E N T ::      \E[0m\n\E[37m-dolaczono do kanalu serwera...\n");  
   
};

//***************************************************************************************
void open_own_canal()
{if((inmsg_id=msgget(IPC_PRIVATE,IPC_CREAT|0664))==-1)
	{perror("\E[41;39mBlad przy tworzeniu kanalu do odbioru\E[0m"); exit(0);}
printf("-otwarto wlasny kanal...\E[0m\n");
 
mkdir(downloadDir,0764);

signal(2,clear);
signal(SIGKILL,clear);
};


 
//***************************************************************************************
int login()
{
int OK=0;
char answer[2];
do
{
 strcpy(client_name,"");
  do{
     printf("\E[0m\E[36mLogin: \E[1;39m");scanf("%s",client_name);
	}while(client_name=="");

strcpy(name,client_name);  //zapamietanie w globalnej zmiennej
	  
create_msg(&out_message,1,0,1,1,client_name,inmsg_id,"0");
if(msgsnd(outmsg_id,&out_message,sizeof(message)-sizeof(long),0)==-1)
   {perror("\E[0m\E[41;39mBlad przy probie wyslania numeru wlasnego kanalu\E[0m"); exit(0);}
printf("\E[0m\E[37m-wyslano zapytanie do serwera...\n");  

if(msgrcv(inmsg_id,&in_message,sizeof(message)-sizeof(long),0,0)==-1)
  {perror("\E[41;39mBlad przy logowaniu \E[0m");exit(0);}
printf("\E[0m\E[37m-odebrano potwierdzanie logowania...\n");

if(in_message.command==1){printf("\E[0m\E[37m-zalogowano pomyslnie...\n");OK=1 ;}else
if(in_message.command==11)
  {printf("\E[41;39m-login odrzucony:\E[0m\t\n");
   printf("\E[31m%s\n",in_message.messagebody);OK=0;}else
  {printf("???Niezrozumiala odpowiedz serwera???\n");OK=0;}
 
//answer='n';
strcpy(answer,"n");
 if(OK==0){printf("\E[0m\tPowtorzyc?  t/n  : \E[1;39m");
		   //read(0,&answer,2);OK=0;
		   scanf("%s",answer);
		   OK=0;
		  } 
}while((strcmp(answer,"t")==0)||(strcmp(answer,"T")==0));
return(OK);
}


//**************************************************************************************
void clear(int signal)
{msgctl(inmsg_id,IPC_RMID,0);
 printf("\n\E[0m\E[37m-kanal zamkniety...\E[0m\n");
 exit(signal);
} 

//***************przeprowadza proces wydania polecenia**********************************
int prepare_command()
{char commandtext[51]={0}; 
 int command=0,repeat;
onceagain: 
 strcpy(arg1,""); strcpy(arg2,""); strcpy(path,"");
do
{repeat=0; 
printf("\E[0m\E[36m\n--podaj nazwe komendy:\t>\E[1;39m");
scanf("%s",commandtext);

if(strcmp("logout",commandtext)==0) command=CMD_LOGOUT; else
if(strcmp("share" ,commandtext)==0) command=CMD_SHARE;else
if(strcmp("get"   ,commandtext)==0) command=CMD_GET;else
if(strcmp("list"  ,commandtext)==0) command=CMD_LIST;else
if(strcmp("who"   ,commandtext)==0) command=CMD_WHO;else
if(strcmp("stat"  ,commandtext)==0) command=CMD_STAT;else
if(strcmp("kick"  ,commandtext)==0) command=CMD_KICK;else
if(strcmp("set"   ,commandtext)==0) command=CMD_SET;else
if(strcmp("q"     ,commandtext)==0) command=CMD_LOGOUT;else
if(strcmp("quit"  ,commandtext)==0) command=CMD_LOGOUT;else
if(strcmp(""      ,commandtext)==0) command=0;else
if(strcmp("help"  ,commandtext)==0) command=-1;else
if(strcmp("?"     ,commandtext)==0) command=-1;else
{printf("\E[0m\E[41;39m-konenda nieprawidlowa\E[0m\n\t\E[31m(\"help\" -lista komend)\n");
 repeat=1;}
}while(repeat==1);
printf("\E[0m\E[36m");
switch(command){
	case CMD_SHARE:printf("--podaj lokalizacje udostepnianego zasobu:\n\t>\E[0m");
	             scanf("%s",path);
				 printf("\E[36m--podaj sieciowa nazwe pliku:\n\t>\E[0m");
				 scanf("%s",arg1);
				 printf("\E[36m--podaj nazwe docelowego uzytkownika:\n\t \E[37m[\"\E[0m-\E[37m\" = dostepne dla wszystkich]\n\t\E[36m>\E[0m");
				 scanf("%s",arg2);
				 if(strcmp(arg2,"-")==0)strcpy(arg2,"");
				 break;
	case CMD_GET:printf("--podaj nazwe uzytkownika:\n\t>\E[0m");
				 scanf("%s",arg1);
				 printf("\E[36m--podaj sieciowa nazwe pliku:\n\t>\E[0m");
				 scanf("%s",arg2);
				 
				 break; 
	case CMD_LIST:printf("--podaj nazwe uzytkownika:\n\t \E[37m[\"\E[0m-\E[37m\" = wyswietla pliki wszystkich]\n\t\E[36m>\E[0m");
				 scanf("%s",arg1);
				 if(strcmp(arg1,"-")==0){strcpy(arg1,"");/*printf("pusty\n");*/}
				 break;
	case CMD_KICK:printf("--\E[31m(wymagane prawa administratora)\n\t\E[36mpodaj nazwe uzytkownika :\n\t>\E[0m");
				 scanf("%s",arg1);
				 break;
	case CMD_SET:printf("--\E[31m(wymagane prawa administratora)\n \E[36mpodaj nazwe zmienianego parametru \n\t\E[37m['\E[36mx\E[37m' - Maksymalna liczba uzytkownik�,\n\t\t ilu jednoczesnie moze obsBugiwac serwer.]\n\t['\E[36my\E[37m' - Limit ilosci plik� do udostepnienia,\n\t\t ile moze udostepnic jeden uzytkownik.]\n\t['\E[36mz\E[37m' - Limit transferu bajt�,\n\t\t ile moze pobrac uzytkownik z sieci podczas sesji.]\n\t\E[36m>\E[0m");
				scanf("%s",arg1);
				printf("\E[36m--podaj nowa wartosc:\t>\E[0m");
				scanf("%s",arg2);
				break;
	case -1		:printf("\E[37m\tlogout share get list\n\twho stat kick set\n");
				goto onceagain;
				break;
	}
return(command);
}


//******************wypelnia tablice komunikatow danej komendy**************************
message* prepareMsgTable(int command)
{message* MsgTab;
 message  MsgBuf;
 char msgBody[max_file_size+1];
switch(command){
case CMD_LOGOUT: MsgTab=(message*)malloc(sizeof(message));
				create_msg(&MsgTab[0],inmsg_id,0,1,CMD_LOGOUT,"","","");
				break;

case CMD_GET  :MsgTab=(message*)malloc(sizeof(message));
				create_msg(&MsgTab[0],inmsg_id,0,1,CMD_GET,arg1,arg2,"");
				break;
case CMD_LIST :MsgTab=(message*)malloc(sizeof(message));
				create_msg(&MsgTab[0],inmsg_id,0,1,CMD_LIST,arg1,"","");
				break;
case CMD_WHO  :MsgTab=(message*)malloc(sizeof(message));
				create_msg(&MsgTab[0],inmsg_id,0,1,CMD_WHO,"","","");
				break;
case CMD_STAT :MsgTab=(message*)malloc(sizeof(message));
				create_msg(&MsgTab[0],inmsg_id,0,1,CMD_STAT,"","","");
				break;
case CMD_KICK :MsgTab=(message*)malloc(sizeof(message));
				create_msg(&MsgTab[0],inmsg_id,0,1,CMD_KICK,arg1,"","");break;
case CMD_SET  :MsgTab=(message*)malloc(sizeof(message));
				create_msg(&MsgTab[0],inmsg_id,0,1,CMD_SET,arg1,arg2,"");break;
case CMD_SHARE:if(readFile(path, msgBody)==1){
					create_msg(&MsgBuf,inmsg_id,0,1,CMD_SHARE,arg1,arg2,"");
					MsgTab=prepareMsgTable(MsgBuf, msgBody);
					}
				else {	printf("\E[41;39mblad odczytu\E[0m\n");
						return(NULL);}	 
				break;				
}


return(MsgTab);
}




//********************interpretuje tablice wiad odp serwera****************************
int executeRecivedMsgsTab(message msgTab[])
{char buff[max_file_size];
 char buff2[max_file_size];
 int command=msgTab[0].command;
 if((command>10)&&(command<20))   //serwer zwraca blad
 	{printf("\E[41;39m!!serwer zglasza BLAD!!\E[0m\E[31m\n\t%s\n",msgTab[0].messagebody);}
 else
 {
 catMsgBody(buff, msgTab);	
 switch(command){
 case CMD_LOGOUT:break;
 case CMD_SHARE:break; 
 case CMD_GET:  if(writeFile(downloadDir,"",msgTab[0].argument2,buff)==1)
					strcpy(buff,"\E[37mPlik pobrano pomyslnie\E[0m\n");
				else
					{printf("\E[41;39mPlik pobrano, ale nie zapisano\E[0m\n");
					 strcpy(buff,error);
					}
 case CMD_LIST: strcpy(buff2,"\E[0m\E[37mNazwa uzytkownika / nazwa pliku\E[0m\n");
 				strcat(buff2, buff);
				strcpy(buff, buff2);
 				break; 
 case CMD_WHO:  break; 
 case CMD_STAT: if(strcmp(name,"admin")!=0)  //czyli nie jest administratorem
 					{editStatString(buff2, buff);}
					else
					{editStatStringAdmin(buff2, buff);}
				strcpy(buff, buff2);	
				break; 
 case CMD_KICK: break; 
 case CMD_SET:  break; 
 }
 printf("\E[37modp:\E[0m\n");printf("%s\E[0m\n",buff);
 }
}


//**************************************************************************************
//*                        KLIENT                                                      *
//**************************************************************************************
int main(int argc,char *argv[])
{int loged=0,
     command;
join_serwer_canal();
open_own_canal();
loged=login();
if(loged!=0)
do
{
command=prepare_command();
if(command>1)
  {if(sendMsgTab(outmsg_id, prepareMsgTable(command) )==1)
     //odbiera wszystko ze swojego kanalu, i wykonuje odpowiednie dzialania
   //printf("odebrano odpowiedz");
   executeRecivedMsgsTab( reciveMsgsToTab(inmsg_id,0) );
  }
  
}while((command>1) &&(command!=CMD_LOGOUT) );  
clear(0);
};



